#include "hdfi.h"
#include "cris.h"
#include "sis.h"
#include "crisSisGetUtilities.h"

uint32 getLastValidSecondOfStruct(void *pStruct, char *structName) {
    uint32 lastValidSecond;

	/* non-periodic types... */
    lastValidSecond = getStopTimeStamp(pStruct, structName);

	/* periodic types... */
    if (lastValidSecond == 0) {
	lastValidSecond = getTimeStamp(pStruct, structName);
	lastValidSecond += getDataTypePeriodFromStructName(structName);
	lastValidSecond--;
    }

    return lastValidSecond;
}
