/* $Id: cvtFromSec1996.c,v 1.4 1999/03/18 21:11:15 bruce Exp $ */

/* $RCSfile: cvtFromSec1996.c,v $ */
/* $Author: bruce $ */
/* $Date: 1999/03/18 21:11:15 $ */
/* $Revision: 1.4 $ */

/* This function takes a time expresed in seconds of year of 1996 */
/* and returns an AceTime structure.                              */
/*                                                                */
/*                                                                */
/* Arguments                                                      */
/*   time = set of times to be converted - input                  */

#include <sys/types.h>
#include "AceTime.h"

#include "utilities.h"

#ifndef u_long
#define u_long unsigned long
#endif


struct AceTime cvtFromSec1996(u_long Second1996)
{
   static u_long MonthTable[((2040 - 1996) + 1) * 12];
     static long nmonth = 0;
   static u_long SecTypicalMonth;

   struct AceTime time;
             long month;
             long seconds;
             long leap_seconds;
   

   /* If the month table that holds the number of seconds since 1996 */
   /* has not been initialized, then initialize it before proceeding. */

   if (!nmonth) {
      initTabSec1996(MonthTable);
      nmonth = (long) (((2040 - 1996) + 1) * 12);
      SecTypicalMonth = (u_long) (((3*365 + 366) * 86400)/(4*12));
   }
   
   /* Find the month in which the time falls */
   
   month = (long) (Second1996/SecTypicalMonth);
   if (month < 1L) month = 1L;
   if (Second1996 < MonthTable[month]) month--;
   if (month > (nmonth-2L)) month = nmonth - 2L;
   if (Second1996 >= MonthTable[month+1]) month++;
   
   /* Convert time in seconds of 1996 to (yr,month,day,hr,min,sec) */
   
	/* how many seconds into this month? */
   seconds = (long) (Second1996 - MonthTable[month]);

   time.year =  month/12L + 1996L;
   time.month = (month % 12L) + 1L;
   time.day = seconds/86400L + 1L;
   time.hour = (seconds/3600L) % 24L;
   time.min = (seconds/60L) % 60L;
   time.sec = seconds % 60L;


   /* Adjustment for June leap seconds */

   if ((time.month == 6L) && (time.day == 31L)) {
/*
      time.day -= 1L;
      time.hour += 24L;
*/

      leap_seconds = (seconds % 86400L) + 1L;

      time.day = 30L;
      time.hour = 23L;
      time.min = 59L;
      time.sec = 59L + leap_seconds;
   }

   /* Adjustment for December leap seconds */

   if ((time.month == 12L) && (time.day == 32L)) {
/*
      time.day -= 1L;
      time.hour += 24L;
*/

      leap_seconds = (seconds % 86400L) + 1L;

      time.day = 31L;
      time.hour = 23L;
      time.min = 59L;
      time.sec = 59L + leap_seconds;
   }
   
   return time;
}
